SystemOrganization addCategory: #'StashShell-NIX'!

StashCommand subclass: #StashNIXBuiltInCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXBuiltInCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	self subclassResponsibility! !

!StashNIXBuiltInCommand classSide methodsFor: 'instance creation' stamp: 'DaleHenrichs 12/9/2010 15:59'!
new

	^(super new)
		command: self commandString; 
		yourself! !

StashNIXBuiltInCommand subclass: #StashNIXcdCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXcdCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 18:04'!
commandString

	^'cd'! !

!StashNIXcdCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 15:19'!
executeIn: aShell withArgs: argsString
	| args paths debug |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self missingOperandError ].
	paths := OrderedCollection new.
	self getopts: args into: paths.
	debug := self options includes: #'-d'.
	[ 
	aShell
		path: ([ aShell resolvePathFromPathString: paths first ] on: StashShellNoSuchChild do: [ :ex | ex resume: false ]).
	^ '' ]
		on: Error
		do: [ :ex | 
			debug
				ifTrue: [ self halt ].
			^ self command , ': ' , argsString , ': ' , ex messageText ]! !

!StashNIXcdCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:20'!
usage

	^'cd [-d] [dir]'! !

!StashNIXcdCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:19'!
validArgs

	^#('-d')! !

StashNIXBuiltInCommand subclass: #StashNIXhelpCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXhelpCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'help'! !

!StashNIXhelpCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 10:27'!
executeIn: aShell withArgs: argsString
	| args |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self helpText: aShell ].
	self halt! !

!StashNIXhelpCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 12:34'!
helpText: aShell
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'Smaltalk shell, version ' , ConfigurationOfStashShell project currentVersion versionString;
		cr;
		nextPutAll: 'These shell commands are defined internally.';
		cr;
		nextPutAll: 'Type ''help'' to see this list.';
		cr;
		nextPutAll: 'Type ''help name'' to find out more about the function ''name''.';
		cr;
		nextPutAll: 'Use ''info stash'' to find out more about she shell in general.';
		cr.
	(aShell builtinCommands values asArray sort: [ :a :b | a name <= b name ])
		do: [ :cmd | 
			stream
				cr;
				nextPutAll: cmd usage ].
	^ stream contents! !

!StashNIXhelpCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:51'!
usage

	^'help [-d] [functionName]'! !

!StashNIXhelpCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:51'!
validArgs

	^#('-d')! !

StashNIXBuiltInCommand subclass: #StashNIXlsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXlsCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'ls'! !

!StashNIXlsCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 15:52'!
executeIn: aShell withArgs: argsString
	| args paths stream first showNodeName pathSize debug |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ aShell path last listContents ].
	paths := OrderedCollection new.
	self getopts: args into: paths.
	debug := self options includes: #'-d'.
	stream := WriteStream on: String new.
	first := true.
	showNodeName := paths size > 1.
	pathSize := paths size.
	1 to: pathSize do: [ :pathIndex | 
		| parentFolder |
		[ 
		parentFolder := ([ aShell resolvePathFromPathString: (paths at: pathIndex) ]
			on: StashShellNoSuchChild
			do: [ :ex | ex resume: false ]) last.
		first
			ifFalse: [ stream cr ].
		first := false.
		showNodeName
			ifTrue: [ 
				stream
					nextPutAll: parentFolder name , ':';
					cr ].
		parentFolder isFolder
			ifTrue: [ stream nextPutAll: parentFolder listContents ]
			ifFalse: [ stream nextPutAll: parentFolder name ].
		pathSize > pathIndex
			ifTrue: [ stream cr ] ]
			on: Error
			do: [ :ex | 
				debug
					ifTrue: [ self halt ].
				stream nextPutAll: self command , ': ' , argsString , ': ' , ex messageText ] ].
	^ stream contents! !

!StashNIXlsCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:51'!
usage

	^'ls [-d]'! !

!StashNIXlsCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:51'!
validArgs

	^#('-d')! !

StashNIXBuiltInCommand subclass: #StashNIXmkdirCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXmkdirCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 16:00'!
commandString

	^'mkdir'! !

!StashNIXmkdirCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 15:48'!
executeIn: aShell withArgs: argsString
	| args childNode paths argCount argIndex stream first debug |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self missingOperandError ].
	paths := OrderedCollection new.
	self getopts: args into: paths.
	debug := self options includes: #'-d'.
	stream := WriteStream on: String new.
	first := true.
	paths
		do: [ :pathString | 
			[ 
			| path parentFolder folder |
			path := [ aShell resolvePathFromPathString: pathString ] on: StashShellNoSuchChild do: [ :ex | ex resume: false ].
			folder := path removeLast.
			parentFolder := path last.
			parentFolder mkdir: folder name ]
				on: Error
				do: [ :ex | 
					debug ifTrue: [ self halt ].
					first
						ifFalse: [ stream cr ].
					first := false.
					stream nextPutAll: self command , ': ' , argsString , ': ' , ex messageText ] ].
	^ stream contents! !

!StashNIXmkdirCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:47'!
usage

	^'mkdir [-d]... DIRECTORY...'! !

!StashNIXmkdirCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:47'!
validArgs

	^#('-d')! !

StashNIXBuiltInCommand subclass: #StashNIXmountCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXmountCommand classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:39'!
commandString

	^'mount'! !

!StashNIXmountCommand methodsFor: 'execution' stamp: 'DaleHenrichs 12/11/2010 16:02'!
executeIn: aShell withArgs: argsString
	| args devices debug |
	args := self parser parse: argsString.
	args isPetitFailure
		ifTrue: [ ^ self argsParsingError ].
	args isEmpty
		ifTrue: [ ^ self halt: 'list mount status' ].
	devices := OrderedCollection new.
	self getopts: args into: devices.
	debug := self options includes: #'-d'.
	[ 
	| devPath dirPath device mountPoint directory |
	devPath := aShell resolvePathFromPathString: (devices at: 1).
	dirPath := [ aShell resolvePathFromPathString: (devices at: 2) ]
		on: StashShellNoSuchChild
		do: [ :ex | ex resume: false ].
	device := devPath last object.
	mountPoint := dirPath removeLast.
	directory := dirPath last object.
	directory isNIXDirectory
		ifFalse: [ self halt ].
	device isMountable
		ifFalse: [ self halt ].
	device name: mountPoint name.
	directory addChild: device.
	^ '' ]
		on: Error
		do: [ :ex | 
			debug
				ifTrue: [ self halt ].
			^ self command , ': ' , argsString , ': ' , ex messageText ]! !

!StashNIXmountCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:11'!
usage

	^'mount [-d] device mount_point'! !

!StashNIXmountCommand methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:12'!
validArgs

	^#('-d')! !

StashVirtualMachine subclass: #StashNIXMachine
	instanceVariableNames: 'builtinCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 09:57'!
builtinCommands
	builtinCommands
		ifNil: [ 
			builtinCommands := Dictionary new.
			StashNIXBuiltInCommand subclasses do: [ :cmdClass | builtinCommands at: cmdClass commandString asSymbol put: cmdClass new ] ].
	^ builtinCommands! !

!StashNIXMachine methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:21'!
defaultRoot
	| directory |
	(directory := (StashNIXDirectory new)
		name: '/';
		yourself)
		addChild: StashNIXdev new;
		yourself.
	^ directory! !

!StashDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 15:05'!
isNIXDirectory

	^false! !

!StashDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:37'!
listContents
	^self listContentsWithOptions: #()! !

!StashDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:21'!
listContentsWithOptions: options
	self subclassResponsibility! !

!StashDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:21'!
mkdir: childName

	self subclassResponsibility! !

StashDevice subclass: #StashNIXDirectory
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXDirectory methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:19'!
addChild: aStashChildNode

	aStashChildNode parent: self.
	self children at: aStashChildNode name put: aStashChildNode.
	^aStashChildNode! !

!StashNIXDirectory methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:32'!
children

	children ifNil: [ children := Dictionary new ].
	^ children! !

!StashNIXDirectory methodsFor: 'accessing' stamp: 'DaleHenrichs 12/9/2010 14:31'!
children: anObject
	children := anObject! !

!StashNIXDirectory methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 15:07'!
isNIXDirectory

	^true! !

!StashNIXDirectory methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 16:04'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	(options includes: #full)
		ifTrue: [ 
			stream nextPutAll: '.'.
			first := false.
			self parent
				ifNotNil: [ 
					stream
						cr;
						nextPutAll: '..' ] ].
	(self children values asArray sort: [ :a :b | a name <= b name ])
		do: [ :child | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: child name.
			first := false ].
	^ stream contents! !

!StashNIXDirectory methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 13:19'!
mkdir: childName
	^(self hasChildNamed: childName)
		ifTrue: [ self error: 'cannot create directory: ', childName printString , ': File exists' ]
		ifFalse: [ 
			self
				addChild:
					((self class new)
						name: childName;
						yourself) ]! !

StashDevice subclass: #StashNIXdev
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-NIX'!

!StashNIXdev methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:28'!
children
	| dict |
	dict := Dictionary new.
	(StashDevice subclasses select: [ :cl | cl isMountable ]) collect: [ :cl | dict at: cl mountName put: cl new ].
	^ dict! !

!StashNIXdev methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 15:28'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	(self children values asArray
		sort: [ :a :b | a name < b name ])
		do: [ :dev | 
			first
				ifFalse: [ stream cr ].
			first := false.
			stream nextPutAll: dev name ].
	^ stream contents! !

!StashNIXdev methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:20'!
name
	^'dev'! !

!StashNIXdev methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 15:46'!
shellDeviceClass

	^StashShellFile! !

!StashShellDevice methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 12:13'!
listContentsWithOptions: options
	^self object listContentsWithOptions: options! !

!StashShellFile methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 15:36'!
listContentsWithOptions: options
	^self shouldNotImplement! !

!StashShellFolder methodsFor: '*stashshell-nix-builtins' stamp: 'DaleHenrichs 12/11/2010 15:37'!
mkdir: childName

	^self object mkdir: childName
! !
